# ecmwf soko settings for perfume-processing-lines
---
ecmwf_soko_resources:

  remote_ecmwf_model_output:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_{{ area.short_name }}_090_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}$"
    input_search_url_patterns:
      - "ftp://ftp-data-source"
      - "ftp://192.168.150.112"

  remote_ecmwf_precipitation:
    name_patterns:
      - "ECMWF_OPER_PREC_DESACUMULADO_ATP_090_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}"
    input_search_url_patterns:
      - "ftp://ftp-data-source"
      - "ftp://192.168.150.112"

  ecmwf_model_output_multi_level:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_{{ area.short_name }}_090_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}$"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/raw_data/ecmwf_multi_level/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"
    output_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/raw_data/ecmwf_multi_level/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  ecmwf_precipitation:
    name_patterns:
      - "ECMWF_OPER_PREC_DESACUMULADO_ATP_090_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/raw_data/ecmwf_multi_level/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"
    output_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/raw_data/ecmwf_multi_level/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  ecmwf_variable_multi_level:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_{{ area.short_name }}_090_{{ grib_var.short_name }}_{{ aux_id }}_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_u10m:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_10u_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_v10m:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_10v_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_u:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_u_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_v:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_v_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_intensity:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_wind-intensity_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_intensity10m:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_wind-intensity-10m_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_direction:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_wind-direction_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_direction10m:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_wind-direction-10m_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_uv:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_wind-uv_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"

  wind_uv10m:
    name_patterns:
      - "ECMWF_OPER_001_FC_SP_ATP_090_wind-uv-10m_merc_{% raw %}{{ timeslot|format('%Y%m%d%H') }}{% endraw %}.nc"
    input_search_url_patterns:
      - "{% raw %}{{ DATA_ROOT }}/output/innometeo_ecmwf/{{ timeslot|format('%Y/%m/%d') }}{% endraw %}"


ecmwf_soko_packages:

  retrieve_ecmwf_input:
    process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/extract_grib_vars.py:retrieve_grib_input{% endraw %}"
    inputs:  [{resource: "remote_ecmwf_model_output"}]
    outputs: [{resource: "ecmwf_model_output_multi_level"}]

  extract_grib_var:
    process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/extract_grib_vars.py:extract_data{% endraw %}"
    callback_arguments: "{{ soko_cbargs }}"
    inputs: "{{ soko_inputs }}"
    outputs: "{{ soko_outputs }}"


ecmwf_default_extract_task_args: 
  pool: "high"
  temporal_slot_context_key: "next_execution_date"
  soko_package: "extract_ecmwf_variable"
  soko_settings:
    packages:
      extract_ecmwf_variable: "{{ ecmwf_soko_packages.extract_grib_var }}"
    resources:
      ecmwf_model_output_multi_level: "{{ ecmwf_soko_resources.ecmwf_model_output_multi_level }}"
      ecmwf_variable_multi_level: "{{ ecmwf_soko_resources.ecmwf_variable_multi_level }}"


ecmwf_extract_precipitation_task_args:
  pool: high
  temporal_slot_context_key: next_execution_date
  soko_package: extract_ecmwf_variable
  soko_settings:
    packages:
      extract_ecmwf_variable: "{{ ecmwf_soko_packages.extract_grib_var }}"
    resources:
      ecmwf_precipitation: "{{ ecmwf_soko_resources.ecmwf_precipitation }}"
      ecmwf_variable_multi_level: "{{ ecmwf_soko_resources.ecmwf_variable_multi_level }}"


ecmwf_publish_task_args:
  pool: low
  temporal_slot_context_key: next_execution_date
  soko_package: publish_granules
  soko_settings:
    packages:
      publish_granules:
        process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/publish_granules.py:main{% endraw %}"
        callback_arguments:
          var_name: "{{ grib_var.short_name }}"
          data_source: "ecmwf"
        inputs:
          - resource: ecmwf_variable_multi_level
    resources:
      ecmwf_variable_multi_level: "{{ ecmwf_soko_resources.ecmwf_variable_multi_level }}"


ecmwf_cache_warmup_task_args:
  pool: low
  temporal_slot_context_key: next_execution_date
  soko_package: cache_warmup
  soko_settings:
    packages:
      cache_warmup:
        process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/cachewarmup.py:main{% endraw %}"
        callback_arguments:
          var_name: "{{ grib_var.short_name }}"
          data_source: "ecmwf"


ecmwf_area_template_tasks:

  delay_execution:
    operator: "airflow.operators.sensors.TimeDeltaSensor"
    task_args:
      delta: "hours=7"
      poke_interval: 300
      pool: 'low'

  retrieve_input:
    operator: "sokoplugin.SokoOperator"
    task_args:
      retries: 72  # expect inputs with 6 hours delay
      retry_delay: "minutes=5"
      pool: "medium"
      temporal_slot_context_key: "next_execution_date"
      soko_package: "retrieve_ecmwf_input"
      soko_settings:
        packages:
          retrieve_ecmwf_input: "{{ ecmwf_soko_packages.retrieve_ecmwf_input}}"
        resources:
          remote_ecmwf_model_output: "{{ ecmwf_soko_resources.remote_ecmwf_model_output }}"
          ecmwf_model_output_multi_level: "{{ ecmwf_soko_resources.ecmwf_model_output_multi_level }}"
        context: "{{ soko_context }}"
    relationships: {upstream: ["delay_execution"]}

  extract_temperature:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 't', name: 'temperature'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_temperature:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: t
      name: temperature
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_temperature

  extract_temperature_2m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: '2t',  name: 'temperature_2m'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_temperature_2m:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: 2t
      name: temperature_2m
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_temperature_2m

  warm_up_featureinfoserver_cache_temperature:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: t
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_temperature
        - extract_temperature_2m

  extract_dewpoint_temperature_2m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: '2d',  name: 'dewpoint_temperature_2m'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_dewpoint_temperature_2m:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: 2d
      name: dewpoint_temperature_2m
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_dewpoint_temperature_2m

  warm_up_featureinfoserver_cache_dewpoint_temperature:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: 2d
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_dewpoint_temperature_2m

  extract_boundary_layer_height:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'blh',  name: 'boundary_layer_height'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_boundary_layer_height:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: blh
#      name: boundary_layer_height
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_boundary_layer_height
#

  extract_convective_available_potential_energy:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'cape',
               name: 'convective_available_potential_energy'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_convective_available_potential_energy:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: cape
      name: convective_available_potential_energy
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_convective_available_potential_energy

  warm_up_featureinfoserver_cache_convective_available_potential_energy:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: cape
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_convective_available_potential_energy

  extract_convective_available_potential_energy_shear:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'capes',
               name: 'convective_available_potential_energy_shear'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_convective_available_potential_energy_shear:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: capes
      name: convective_available_potential_energy_shear
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_convective_available_potential_energy_shear

  warm_up_featureinfoserver_cache_convective_available_potential_energy_shear:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: capes
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_convective_available_potential_energy_shear

  extract_zero_degrees_isothermal_level:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'deg0l',  name: 'zero_degrees_isothermal_level'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_zero_degrees_isothermal_level:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: deg0l
#      name: zero_degrees_isothermal_level
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_zero_degrees_isothermal_level

  extract_convective_cloud_top_height:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'hcct',  name: 'convective_cloud_top_height'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_convective_cloud_top_height:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: hcct
#      name: convective_cloud_top_height
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_convective_cloud_top_height

  extract_low_cloud_cover:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'lcc',  name: 'low_cloud_cover'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_low_cloud_cover:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: lcc
#      name: low_cloud_cover
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_low_cloud_cover

  extract_medium_cloud_cover:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'mcc',  name: 'medium_cloud_cover'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_medium_cloud_cover:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: mcc
#      name: medium_cloud_cover
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_medium_cloud_cover

  extract_high_cloud_cover:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'hcc',  name: 'high_cloud_cover'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_high_cloud_cover:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: hcc
#      name: high_cloud_cover
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_high_cloud_cover

  extract_mean_sea_level_pressure:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'msl',  name: 'mean_sea_level_pressure'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_mean_sea_level_pressure:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: msl
      name: mean_sea_level_pressure
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_mean_sea_level_pressure

  warm_up_featureinfoserver_cache_mean_sea_level_pressure:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: msl
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_mean_sea_level_pressure

  extract_relative_humidity:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'r',  name: 'relative_humidity'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an'],
                      typeOfLevel: ['isobaricInhPa']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_relative_humidity:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: r
      name: relative_humidity
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_relative_humidity

  extract_relative_humidity_2m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'r',  name: 'relative_humidity_2m'}
    aux_id: '2m-merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      typeOfLevel: ['surface']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_relative_humidity_2m:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: r
      name: relative_humidity_2m
    aux_id: 2m-merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_relative_humidity_2m

  warm_up_featureinfoserver_cache_relative_humidity:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: r
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_relative_humidity
        - extract_relative_humidity_2m

  extract_total_cloud_cover:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'tcc', name: 'total_cloud_cover'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_total_cloud_cover:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: tcc
#      name: total_cloud_cover
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_total_cloud_cover

  extract_sea_surface_temperature:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'sst', name: 'sea_surface_temperature'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_sea_surface_temperature:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: sst
#      name: sea_surface_temperature
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_sea_surface_temperature

  extract_surface_solar_radiation_downwards:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'ssrd',
               name: 'surface_solar_radiation_downwards'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_surface_solar_radiation_downwards:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: ssrd
#      name: surface_solar_radiation_downwards
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_surface_solar_radiation_downwards

  extract_downward_uv_surface_radiation:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'uvb',
               name: 'downward_uv_surface_radiation'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_downward_uv_surface_radiation:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: uvb
#      name: downward_uv_surface_radiation
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_downward_uv_surface_radiation

  extract_wind_gust_10m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: '10fg',  name: 'wind_gust_10m'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_wind_gust_10m:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: 10fg
#      name: wind_gust_10m
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_wind_gust_10m

  extract_wind_gust3_10m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: '10fg3',  name: 'wind_gust3_10m'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}"}] 
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_wind_gust3_10m:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: 10fg3
#      name: wind_gust3_10m
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_wind_gust3_10m

  extract_wind_u_10m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: '10u',  name: 'wind_u_10m'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_wind_u_10m:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: 10u
#      name: wind_u_10m
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_wind_u_10m

  extract_wind_v_10m:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: '10v',  name: 'wind_v_10m'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_wind_v_10m:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: 10v
#      name: wind_v_10m
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_wind_v_10m

  extract_wind_u_component:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'u',  name: 'wind_u_component'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  extract_wind_v_component:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'v',  name: 'wind_v_component'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  extract_wind_vertical_component:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'w',  name: 'wind_vertical_component'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  # not implemented in the spatial-data-server yet
#  publish_wind_vertical_component:
#    operator: sokoplugin.SokoOperator
#    grib_var:
#      short_name: w
#      name: wind_vertical_component
#    aux_id: merc
#    task_args: "{{ ecmwf_publish_task_args }}"
#    relationships:
#      upstream:
#        - extract_wind_vertical_component

  extract_geopotential:
    operator: "sokoplugin.SokoOperator"
    grib_var: {short_name: 'z',  name: 'geopotential'}
    aux_id: 'merc'
    soko_cbargs:
      grib_filters: [{shortName: "{{ grib_var.short_name }}",
                      dataType: ['fc', 'an'],
                      typeOfLevel: ['isobaricInhPa']}]
      trg_proj_str: '+init=epsg:3857 +ellps=WGS84'
    soko_inputs: [{resource: "ecmwf_model_output_multi_level"}]
    soko_outputs: [{resource: "ecmwf_variable_multi_level"}]
    task_args: "{{ ecmwf_default_extract_task_args }}"
    relationships: {upstream: ["retrieve_input"]}

  publish_geopotential:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: z
      name: geopotential
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_geopotential

  warm_up_featureinfoserver_cache_geopotential:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: z
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_geopotential

  retrieve_precipitation_input:
    operator: sokoplugin.SokoOperator
    task_args:
      retries: 72  # expect inputs with 6 hours of delay
      retry_delay: "minutes=5"
      pool: medium
      temporal_slot_context_key: next_execution_date
      soko_package: retrieve_ecmwf_precipitation
      soko_settings:
        packages:
          retrieve_ecmwf_precipitation:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/extract_grib_vars.py:retrieve_grib_input{% endraw %}"
            inputs:
              - resource: remote_ecmwf_precipitation
            outputs:
              - resource: ecmwf_precipitation
        resources:
          remote_ecmwf_precipitation: "{{ ecmwf_soko_resources.remote_ecmwf_precipitation }}"
          ecmwf_precipitation: "{{ ecmwf_soko_resources.ecmwf_precipitation }}"
        context: "{{ soko_context }}"
    relationships:
      upstream:
        - delay_execution

  extract_precipitation:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: pcp
    aux_id: merc
    soko_cbargs:
      grib_filters:
        - cfVarName: "p83.128"
          dataType:
            - undef
      trg_proj_str: "+init=epsg:3857 +ellps=WGS84"
    soko_inputs:
      - resource: ecmwf_precipitation
    soko_outputs:
      - resource: ecmwf_variable_multi_level
    task_args: "{{ ecmwf_extract_precipitation_task_args }}"
    relationships:
      upstream:
        - retrieve_precipitation_input

  publish_precipitation:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: pcp
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - extract_precipitation

  warm_up_featureinfoserver_cache_precipitation:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: pcp
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - extract_precipitation

  generate_wind_intensity_10m:
    operator: sokoplugin.SokoOperator
    task_args:
      pool: high
      temporal_slot_context_key: next_execution_date
      soko_package: generate_wind_intensity
      soko_settings:
        packages:
          generate_wind_intensity:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/windprocessor.py:generate_wind_intensity{% endraw %}"
            inputs:
              - resource: wind_u10m
              - resource: wind_v10m
            outputs:
              - resource: wind_intensity10m
        resources:
          wind_u10m: "{{ ecmwf_soko_resources.wind_u10m }}"
          wind_v10m: "{{ ecmwf_soko_resources.wind_v10m }}"
          wind_intensity10m: "{{ ecmwf_soko_resources.wind_intensity10m }}"
    relationships:
      upstream:
        - extract_wind_u_10m
        - extract_wind_v_10m

  publish_wind_intensity_10m:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: wind-intensity-10m
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - generate_wind_intensity_10m

  generate_wind_intensity:
    operator: sokoplugin.SokoOperator
    task_args:
      pool: high
      temporal_slot_context_key: next_execution_date
      soko_package: generate_wind_intensity
      soko_settings:
        packages:
          generate_wind_intensity:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/windprocessor.py:generate_wind_intensity{% endraw %}"
            inputs:
              - resource: wind_u
              - resource: wind_v
            outputs:
              - resource: wind_intensity
        resources:
          wind_u: "{{ ecmwf_soko_resources.wind_u }}"
          wind_v: "{{ ecmwf_soko_resources.wind_v }}"
          wind_intensity: "{{ ecmwf_soko_resources.wind_intensity }}"
    relationships:
      upstream:
        - extract_wind_u_component
        - extract_wind_v_component

  publish_wind_intensity:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: wind-intensity
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - generate_wind_intensity

  warm_up_featureinfoserver_cache_wind_intensity:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: wind-intensity
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - generate_wind_intensity
        - generate_wind_intensity_10m

  generate_wind_direction_10m:
    operator: sokoplugin.SokoOperator
    task_args:
      pool: high
      temporal_slot_context_key: next_execution_date
      soko_package: generate_wind_direction
      soko_settings:
        packages:
          generate_wind_direction:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/windprocessor.py:generate_wind_direction{% endraw %}"
            inputs:
              - resource: wind_u10m
              - resource: wind_v10m
            outputs:
              - resource: wind_direction10m
        resources:
          wind_u10m: "{{ ecmwf_soko_resources.wind_u10m }}"
          wind_v10m: "{{ ecmwf_soko_resources.wind_v10m }}"
          wind_direction10m: "{{ ecmwf_soko_resources.wind_direction10m }}"
    relationships:
      upstream:
        - extract_wind_u_10m
        - extract_wind_v_10m

  generate_wind_direction:
    operator: sokoplugin.SokoOperator
    task_args:
      pool: high
      temporal_slot_context_key: next_execution_date
      soko_package: generate_wind_direction
      soko_settings:
        packages:
          generate_wind_direction:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/windprocessor.py:generate_wind_direction{% endraw %}"
            inputs:
              - resource: wind_u
              - resource: wind_v
            outputs:
              - resource: wind_direction
        resources:
          wind_u: "{{ ecmwf_soko_resources.wind_u }}"
          wind_v: "{{ ecmwf_soko_resources.wind_v }}"
          wind_direction: "{{ ecmwf_soko_resources.wind_direction }}"
    relationships:
      upstream:
        - extract_wind_u_component
        - extract_wind_v_component

  warm_up_featureinfoserver_cache_wind_direction:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: wind-direction
    task_args: "{{ ecmwf_cache_warmup_task_args }}"
    relationships:
      upstream:
        - generate_wind_direction
        - generate_wind_direction_10m

  generate_wind_uv:
    operator: sokoplugin.SokoOperator
    task_args:
      pool: high
      temporal_slot_context_key: next_execution_date
      soko_package: generate_combined_wind
      soko_settings:
        packages:
          generate_combined_wind:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/windprocessor.py:generate_combined_wind{% endraw %}"
            inputs:
              - resource: wind_u
              - resource: wind_v
            outputs:
              - resource: wind_uv
        resources:
          wind_u: "{{ ecmwf_soko_resources.wind_u }}"
          wind_v: "{{ ecmwf_soko_resources.wind_v }}"
          wind_uv: "{{ ecmwf_soko_resources.wind_uv }}"
    relationships:
      upstream:
        - extract_wind_u_component
        - extract_wind_v_component

  publish_wind_uv:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: wind-uv
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - generate_wind_uv

  generate_wind_uv_10m:
    operator: sokoplugin.SokoOperator
    task_args:
      pool: high
      temporal_slot_context_key: next_execution_date
      soko_package: generate_combined_wind
      soko_settings:
        packages:
          generate_combined_wind:
            process_callback: "{% raw %}{{ SOKO_HOME }}/tasks/windprocessor.py:generate_combined_wind{% endraw %}"
            inputs:
              - resource: wind_u10m
              - resource: wind_v10m
            outputs:
              - resource: wind_uv10m
        resources:
          wind_u10m: "{{ ecmwf_soko_resources.wind_u10m }}"
          wind_v10m: "{{ ecmwf_soko_resources.wind_v10m }}"
          wind_uv10m: "{{ ecmwf_soko_resources.wind_uv10m }}"
    relationships:
      upstream:
        - extract_wind_u_10m
        - extract_wind_v_10m

  publish_wind_uv_10m:
    operator: sokoplugin.SokoOperator
    grib_var:
      short_name: wind-uv-10m
    aux_id: merc
    task_args: "{{ ecmwf_publish_task_args }}"
    relationships:
      upstream:
        - generate_wind_uv_10m
...
